import React, { useEffect, useMemo, useRef, useState } from "react";
import {
    Dropdown,
    Menu,
    Button,
    Tooltip,
    Row,
    Divider,
    Drawer,
    Table,
    Col,
    Steps,
    Card,
} from "antd";
import AutoTable from "@/components/AutoTable";
import { useRequest } from "umi";
import defaultFields from "./fields";
import { doFetch } from "@/utils/doFetch";
import Details from "@/components/Details";
import { gongyiDetail } from "@/utils/detailTotalCard";
import Coltext from "@/components/Coltext";
import DrawInitForm from "@/components/DrawInitForm";
import styles from "./index.less";
import {
    PlusSquareOutlined,
    MinusSquareOutlined,
    MinusCircleOutlined,
    ArrowDownOutlined,
    ArrowUpOutlined,
} from "@ant-design/icons";
import getPrem from '@/utils/getPrem';//权限判断fn


function Instore(props) {
    console.log(defaultFields)
    const [activeTabKey, onTabChange] = useState("1");
    const [drawprops, setdrawprops] = useState({
        title: "",
        visible: false,
        onClose: () => {
            setdrawprops(s => ({
                ...s,
                visible: false,
            }))
        },
        fields: {}
    });



    const columns = useMemo(() => {
        return [
            {
                "title": "入库单号",
                "dataIndex": "materieInstoreNo",
                "key": "materieInstoreNo"
            },
            {
                "title": "入库类型",
                "dataIndex": "instoreTypeName",
                "key": "instoreType",
                "valueType": "select",
                "options": [
                    {
                        "label": "采购入库",
                        "value": "1"
                    },
                    {
                        "label": "生产入库",
                        "value": "2"
                    },
                    {
                        "label": "退料入库",
                        "value": "3"
                    },
                    {
                        "label": "其他入库",
                        "value": "4"
                    }
                ]
            },
            {
                "title": "入库仓库",
                "dataIndex": "storeName",
                "key": "storeId",
                options: {
                    database: () => doFetch({ url: "/ngic-auth/sysStore/selectionBox", params: { factoryIdList: [] } }),
                    params: {}
                },
                valueType: "select",
            },
            {
                "title": "相关单号",
                "dataIndex": "businessNo",
                "key": "businessNo"
            },
            {
                "title": "备注",
                "dataIndex": "remark",
                "key": "remark",
                "search": false
            },
            {
                "title": "创建人",
                "dataIndex": "createUserName",
                "key": "createUserName"
            },
            {
                "title": "创建时间",
                "dataIndex": "createTime",
                "key": "createTime",
                "search": false
            },
            {
                "title": "创建时间开始时间",
                "dataIndex": "createTimeStart",
                "key": "createTimeStart",
                "valueType": "date",
                "hideInTable": true
            },
            {
                "title": "创建时间结束时间",
                "dataIndex": "createTimeEnd",
                "key": "createTimeEnd",
                "valueType": "date",
                "hideInTable": true
            },
            {
                "title": "状态",
                "dataIndex": "statusName",
                "key": "statusName",
                "valueType": "select",
                "request": [
                    {
                        "label": "待上架",
                        "value": "0"
                    },
                    {
                        "label": "上架中",
                        "value": "1"
                    }
                ]
            },
            {
                "title": "操作",
                "valueType": "option",
                "width": 240,
                "render": (text, row, _, action) => {
                    return [
                        getPrem("equipmentCustomer_save", action, '上架采集', async () => {



                        }),
                        getPrem("equipmentCustomer_deleteById", action, '关单', null, {
                            title: "确认关单？",
                            onConfirm: () => {
                                run({ url: "/ngic-auth/sysCustomer/deleteById", params: { id: record.id } })
                            }
                        }),
                        getPrem("equipmentCustomer_deleteById", action, '删除', null, {
                            title: "确认删除？",
                            onConfirm: () => {
                                run({ url: "/ngic-auth/sysCustomer/deleteById", params: { id: record.id } })
                            }
                        })
                    ];
                }
            }
        ]



    }, [activeTabKey])

    const tableprops = {
        ...props,
        // addconfig: {
        //     premkey: "sysDepartment_save",
        //     btnprops: {},
        //     onClick: () => {
        //         setdrawprops(s => ({
        //             ...s,
        //             visible: true,
        //             title: "新增",
        //             width: 600
        //         }))
        //     },
        // },
        // exportconfig: {
        //     premkey: "sysDepartment_save",
        //     btnprops: {
        //     },
        //     onClick: () => {
        //         alert(1)
        //     },
        // },
        pageextra: activeTabKey == "1" ? <Dropdown placement="bottomRight" overlay={<Menu
            onClick={(e) => {
                console.log(e.key)

                setdrawprops(s => ({
                    ...s,
                    visible: true,
                    title: "新增",
                    width: 800,
                    fields:defaultFields[e.key],
                    instoreType:e.key
                }))
            }}
            items={[
                {
                    key: 'one',
                    label: (
                        <a>
                            采购入库
                        </a>
                    ),
                },
                {
                    key: 'two',
                    label: (
                        <a>
                            生产入库
                        </a>
                    ),
                },
                {
                    key: 'three',
                    label: (
                        <a>
                            退料入库
                        </a>
                    ),
                },
                {
                    key: 'four',
                    label: (
                        <a>
                            其他入库
                        </a>
                    ),
                },
            ]}
        />}>
            <Button type="primary">新增</Button>
        </Dropdown> : "none",
        tabList: [
            {
                tab: "未完成",
                key: "1"
            }, {
                tab: "已完成",
                key: "2"
            }
        ],
        activeTabKey,
        onTabChange,
        columns,
        path: "/ngic-workmanship/wmsMaterieInstore/queryList"
    }


    return (
        <div>
            <AutoTable
                {
                ...tableprops
                }



            ></AutoTable>

            <DrawInitForm
                {...drawprops}
            />



        </div>
    );
}

export default Instore;